<?php
/**
 * Visforms validate date class
 *
 * @author       Aicha Vack
 * @package      Joomla.Site
 * @subpackage   com_visforms
 * @link         https://www.vi-solutions.de
 * @license      GNU General Public License version 2 or later; see license.txt
 * @copyright    2012 vi-solutions
 * @since        Joomla 1.6
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class VisformsValidateTel extends VisformsValidate
{
	protected $value;
	protected $format;
	protected $regexarray = [
        'NANP'  => '/^(?:\+?1[-. ]?)?\(?([2-9][0-8][0-9])\)?[-. ]?([2-9][0-9]{2})[-. ]?([0-9]{4})$/',
        'ITU-T' => '/^\+(?:[0-9] ?){6,14}[0-9]$/',
        'EPP'   => '/^\+[0-9]{1,3}\.[0-9]{4,14}(?:x.+)?$/',
    ];

	public function __construct($type, $args) {
		parent::__construct($type, $args);
		// we expect a key 'value' and a key 'format' in $args
		$this->value = isset($args['value']) ? $args['value'] : "";
		$this->format = isset($args['format']) ? $args['format'] : "";
	}

	protected function test() {
        if (!array_key_exists($this->format, $this->regexarray)) {
            return true;
        }
        $regex = $this->regexarray[$this->format];

        if (!(preg_match($regex, $this->value) == true)) {
            return false;
        }
        else {
            return true;
        }
	}
}