<?php
/**
 * Visforms message email class
 *
 * @author       Aicha Vack
 * @package      Joomla.Site
 * @subpackage   com_visforms
 * @link         https://www.vi-solutions.de
 * @license      GNU General Public License version 2 or later; see license.txt
 * @copyright    2012 vi-solutions
 * @since        Joomla 1.6
 */

namespace  Visolutions\Component\Visforms\Site\Message;

// no direct access
defined('_JEXEC') or die('Restricted access');
use Joomla\CMS\Language\Text;

class DefaultMessage extends Message
{
    protected $text = 'COM_VISFORMS_CUSTOM_VALIDATION_FAILED';

	protected function setMessage(): string {
        // if we have a custom php error message, return ''
        // the custom php error message is added in the business/field class only once to each invalid field
	    if (!empty($this->customText)) {
            return '';
        }
	    else {
            // default message text ($this->text) has 1 placeholder for the field label ($this->name)
            return Text::sprintf($this->text, $this->name);
        }
	}
}